import { Bytes, Reader } from '@preserves/core';
import { attenuate, Caveat, sturdyDecode, sturdyEncode, SturdyRef } from '../sturdy.js';

const [ base, pat ] = process.argv.slice(2);
const baseCap = sturdyDecode(Bytes.fromHex(base ?? '')) as SturdyRef;
const cs = new Reader(pat).next() as Array<Caveat>;
attenuate(baseCap, ... cs).then(derived => {
    console.log(derived.asPreservesText());
    console.log(sturdyEncode(derived).toHex());
});
